/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_TIPOLAUDO                                                                                          */
/* Tabela : TIPOLAUDO                                                                                                          	      */
/*                                                                                                                                                        */
/* Criao:                                                                                                                                          */
/* 14/12/2004 - Rafael dos Santos Lopes                           			                        */
/*                                                                                                                                                        */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPOLAUDO
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOLAUDO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTLAU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMTIPOLAUDO,0) <> NVL(:NEW.NMTIPOLAUDO,0)) THEN
         :NEW.DTULTATUTLAU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOLAUDO', '', 'CDTIPOLAUDO='||:OLD.CDTIPOLAUDO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOLAUDO MODIFY DTULTATUTLAU DEFAULT SYSDATE
/

